// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_authentication_bloc/wyatt_authentication_bloc.dart';

/// {@template authentication_mock_cache_data_source_impl}
/// A data source that manages the cache strategy.
/// This implementation is mocked.
/// {@endtemplate}
class AuthenticationMockCacheDataSourceImpl<Data>
    extends AuthenticationCacheDataSource<Data> {
  /// {@macro authentication_mock_cache_data_source_impl}
  AuthenticationMockCacheDataSourceImpl();

  @override
  Future<void> cacheAccount(Account account) => Future.value();

  /// Always returns null.
  @override
  Future<Account?> getCachedAccount() async {
    await Future<void>.delayed(const Duration(milliseconds: 200));

    return null;
  }

  @override
  Future<void> removeCachedAccount() => Future.value();
}
